﻿using System;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Threading;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            Thread t = new Thread(CheckMethodJitAddress);
            t.IsBackground = true;

            Program pg = new Program();

            {
                pg.ManyCalls();
                CheckMethodJitAddress(false);
            }

            //    Console.ReadLine();
            t.Start(true);

            Thread.Sleep(1000);

            while (true)
            {
                pg.ManyCalls();
                Thread.Sleep(1000);
            }
        }

        static int _called = 0;
        public long ManyCalls()
        {
            Console.WriteLine("called: " + ++_called);
            long sum = 0;

            for (int i = 0; i < (Environment.TickCount % 10_000); i ++)
            {
                sum += i;
            }

            return sum;
        }

        //private static void CheckMethodJitAddress(object obj)
        //{
        //    do
        //    {
        //        MethodInfo mi = typeof(Program).GetMethod("ManyCalls");
        //        RuntimeMethodHandle rmh = mi.MethodHandle;

        //        Console.WriteLine(rmh.GetFunctionPointer().ToString("x"));
        //        Thread.Sleep(1000);
        //    } while ((bool)obj == true);
        //}

        private static void CheckMethodJitAddress(object obj)
        {
            do
            {
                MethodInfo mi = typeof(Program).GetMethod("ManyCalls");
                RuntimeMethodHandle rmh = mi.MethodHandle;

                IntPtr ptr = rmh.GetFunctionPointer();

                byte jmpCode = Marshal.ReadByte(ptr);
                int offset = Marshal.ReadInt32(ptr + 1);

                Console.WriteLine(jmpCode.ToString("x") + ": " + offset.ToString("x8"));

                Thread.Sleep(1000);
            } while ((bool)obj == true);
        }
    }
}
